//ImageJ macro to find the distance between two points and the midslice of a stack.
//Michael Doube

var bones = newArray("other bone", "scapula", "humerus", "radius", "ulna", "metacarpal", "pelvis", "femur", "tibia", "fibula", "metatarsal");

macro "MidPoint [g]" {
name = getTag("0010,0010");
title = getTitle();
getVoxelSize(width, height, depth, unit);
//depth = getNumericTag("0018,0050");
print("Pixel Scale:",width, height, depth, unit);
//Initialise the results window
if (isOpen("Results")) row = nResults;
else row = 0;
//ask us which bone we are looking at
bonedef = "scapula";
for (n=0; n<lengthOf(bones);n++)  if (matches(title, ".*"+bones[n]+".*")) bonedef = bones[n];
Dialog.create("Options");
Dialog.addChoice("Bone: ", bones, bonedef);
Dialog.show();
bone = Dialog.getChoice();
for (n=0; n<lengthOf(bones); n++) {
	if(matches(bones[n], ".*"+bone+".*")) bonen = n;
}

//Locate important landmarks in the stack
//with left click plus shift then left click plus ctrl

leftButton=16;
shift=1;
rightButton=23;
ctrl=2;
x2=-1;
y2=-1;
z2=-1;
flags2=-1;

//set the last value to be determined to be the loop escape value
endz = -1;

while (endz==-1) {
          getCursorLoc(x, y, z, flags);
          if (x!=x2 || y!=y2 || z!=z2 || flags!=flags2) {

//capture the start position with left click plus shift
		if (flags == 17){
			startx = x*width;
			starty = y*height;
			startz = z*depth;
			//voxel counting starts from 0 while slice number starts from 1...
			slicea = z+1;
			print("Start pixel position captured",x, y,z,"\n");
		}		
//capture the end point with left click plus ctrl
		if (flags == 18){
			endx = x*width;
			endy = y*height;
			endz = z*depth;
			sliceb = z+1;
			print("End pixel position captured",x,y,z,"\n");
		}		
	}
	x2=x; y2=y; z2=z; flags2=flags;
	wait(10);
}

distance = sqrt(sqr(startx-endx)+sqr(starty-endy)+sqr(startz-endz));
perpdist = abs(slicea-sliceb)*depth;
midslice = floor((slicea+sliceb)/2);
setSlice(midslice);
print("Distance between clicks:",distance, unit);
print("Slice A is:", slicea);
print("Slice B is:", sliceb);
print("Mid slice is:", midslice);

setResult("Label",row,name);
setResult("Bone Code", row, bonen);
setResult("SliceA",row,slicea);
setResult("SliceB",row,sliceb);
setResult("MidSlice",row,midslice);
setResult("Length ("+unit+")",row,distance);
setResult("Depth ("+unit+")",row,perpdist);
updateResults();
}

function sqr(n) {
	return n*n;
}

//DICOM meta-info handling code

// This function returns the numeric value of the 
// specified tag (e.g., "0018,0050"). Returns NaN 
// (not-a-number) if the tag is not found or it 
// does not have a numeric value.

function getNumericTag(tag) {
	value = getTag(tag);
	if (value=="") return NaN;
	index3 = indexOf(value, "\\");
	if (index3 > 0) value = substring(value, 0, index3);
	return value;
}

// This function returns the value of the specified 
// tag  (e.g., "0010,0010") as a string. Returns "" 
// if the tag is not found.

function getTag(tag) {
	info = getImageInfo();
	index1 = indexOf(info, tag);
	if (index1 == -1) return "";
	index1 = indexOf(info, ":", index1);
	if (index1 == -1) return "";
	index2 = indexOf(info, "\n", index1);
	value = substring(info, index1+1, index2);
	return value;
}
