library("smatr")	
library("RMySQL")
library("MASS")
m <- dbDriver("MySQL")
con <- dbConnect(m, host="blackbeauty.rvc.ac.uk", user= "ruser", password = "rpassword", dbname = "scaling")
data <- dbGetQuery(con, "
SELECT 
	animals.order_ AS 'order', 
	concat(animals.genus, ' ', animals.species) AS 'binomial',
	dimensions.bone_code,
	animals.est_body_mass AS mass, 
	dimensions.length_ij AS length,
        slices_w.imax AS imax
FROM
	dimensions,
	animals,
        slices_w 
WHERE
	EXISTS (SELECT slices_w.id FROM slices_w WHERE slices_w.animal_id = animals.id)
	AND animals.id = dimensions.animal_id  
        AND dimensions.bone_code=4
	AND slices_w.animal_id = animals.id
	AND slices_w.bone_code = dimensions.bone_code
	AND slices_w.slice = dimensions.midslice
ORDER BY
	animals.order_,
	dimensions.bone_code,
	binomial
")
dbDisconnect(con);
