SELECT
 animal_id,
 museum,
 museum_id,
 animals.order_ AS 'order',
 concat(animals.genus, ' ', animals.species) AS 'binomial',
 animals.familiar,
 animals.est_body_mass AS 'Mb (kg)',
 #MAX(IF(bone_code = 1, length_ij,NULL)) AS 'scapula',
 MAX(IF(bone_code = 2 AND EXISTS (SELECT slices_w.id FROM slices_w WHERE slices_w.animal_id = animals.id AND slices_w.bone_code = 2), length_ij,NULL)) AS 'humerus',
 MAX(IF(bone_code = 3 AND EXISTS (SELECT slices_w.id FROM slices_w WHERE slices_w.animal_id = animals.id AND slices_w.bone_code = 3), length_ij,NULL)) AS 'radius',
 MAX(IF(bone_code = 4 AND EXISTS (SELECT slices_w.id FROM slices_w WHERE slices_w.animal_id = animals.id AND slices_w.bone_code = 4), length_ij,NULL)) AS 'ulna',
 MAX(IF(bone_code = 5 AND EXISTS (SELECT slices_w.id FROM slices_w WHERE slices_w.animal_id = animals.id AND slices_w.bone_code = 5), length_ij,NULL)) AS 'mc3',
 MAX(IF(bone_code = 7 AND EXISTS (SELECT slices_w.id FROM slices_w WHERE slices_w.animal_id = animals.id AND slices_w.bone_code = 7), length_ij,NULL)) AS 'femur',
 MAX(IF(bone_code = 8 AND EXISTS (SELECT slices_w.id FROM slices_w WHERE slices_w.animal_id = animals.id AND slices_w.bone_code = 8), length_ij,NULL)) AS 'tibia',
 #MAX(IF(bone_code = 9, length_ij,NULL)) AS 'fibula',
 MAX(IF(bone_code = 10 AND EXISTS (SELECT slices_w.id FROM slices_w WHERE slices_w.animal_id = animals.id AND slices_w.bone_code = 10), length_ij,NULL)) AS 'mt3'

FROM
 dimensions, 
 animals,
 bones

WHERE
 animals.id = dimensions.animal_id
 AND (animals.order_ = 'Artiodactyla'
     OR animals.order_ = 'Diprotodontia')
 AND EXISTS (SELECT slices_w.id FROM slices_w WHERE slices_w.animal_id = animals.id)
# AND est_body_mass is null

GROUP BY
 dimensions.animal_id
 
ORDER BY
 animals.order_,
 #binomial
 est_body_mass